if nixio.fs.access("/etc/init.d/asterisk")then
server="asterisk"
elseif nixio.fs.access("/etc/init.d/freeswitch")then
server="freeswitch"
else
server=""
end
modulename="pbx-voip"
m=Map(modulename,translate("SIP Accounts"),
translate("This is where you set up your SIP (VoIP) accounts ts like Sipgate, SipSorcery, \
        the popular Betamax providers, and any other providers with SIP settings in order to start \
        using them for dialing and receiving calls (SIP uri and real phone calls). Click \"Add\" to \
        add as many accounts as you wish."))
function m.on_after_commit(e)
commit=false
m.uci:foreach(modulename,"voip_provider",
function(e)
if e.defaultuser~=nil and e.host~=nil then
name=string.gsub(e.defaultuser.."_"..e.host,"%W","_")
if e.name~=name then
m.uci:set(modulename,e['.name'],"name",name)
commit=true
end
end
end)
if commit==true then m.uci:commit(modulename)end
luci.sys.call("/etc/init.d/pbx-"..server.." restart 1\>/dev/null 2\>/dev/null")
luci.sys.call("/etc/init.d/"..server.." restart 1\>/dev/null 2\>/dev/null")
end
s=m:section(TypedSection,"voip_provider",translate("SIP Provider Accounts"))
s.anonymous=true
s.addremove=true
s:option(Value,"defaultuser",translate("User Name"))
pwd=s:option(Value,"secret",translate("Password"),
translate("When your password is saved, it disappears from this field and is not displayed \
                         for your protection. The previously saved password will be changed only when you \
                         enter a value different from the saved one."))
pwd.password=true
pwd.rmempty=false
function pwd.cfgvalue(e,e)
return""
end
function pwd.write(t,a,e)
local o=m:get(a,t.option)
if e and#e>0 and o~=e then
Value.write(t,a,e)
end
end
h=s:option(Value,"host",translate("SIP Server/Registrar"))
h.datatype="host"
p=s:option(ListValue,"register",translate("Enable Incoming Calls (Register via SIP)"),
translate("This option should be set to \"Yes\" if you have a DID \(real telephone number\) \
                        associated with this SIP account or want to receive SIP uri calls through this \
                        provider."))
p:value("yes",translate("Yes"))
p:value("no",translate("No"))
p.default="yes"
p=s:option(ListValue,"make_outgoing_calls",translate("Enable Outgoing Calls"),
translate("Use this account to make outgoing calls."))
p:value("yes",translate("Yes"))
p:value("no",translate("No"))
p.default="yes"
from=s:option(Value,"fromdomain",
translate("SIP Realm (needed by some providers)"))
from.optional=true
from.datatype="host"
port=s:option(Value,"port",translate("SIP Server/Registrar Port"))
port.optional=true
port.datatype="port"
op=s:option(Value,"outboundproxy",translate("Outbound Proxy"))
op.optional=true
op.datatype="host"
return m
