modulename="pbx"
if nixio.fs.access("/etc/init.d/asterisk")then
server="asterisk"
elseif nixio.fs.access("/etc/init.d/freeswitch")then
server="freeswitch"
else
server=""
end
function format_indices(e,t)
if t==nil then
return"Error: No indices to format specified.\n"
end
lines=luci.util.split(luci.util.trim(e),"\n")
splitlines={}
for t,e in ipairs(lines)do
splitlines[t]=luci.util.split(luci.util.trim(e),"%s+",nil,true)
end
output=""
for o,a in ipairs(splitlines)do
loutput=""
for o,t in ipairs(t)do
if a[t]~=nil then
loutput=loutput..e.format("%-40s",a[t])
else
loutput=nil
break
end
end
if loutput~=nil then
output=output..loutput.."\n"
end
end
return output
end
m=Map(modulename,translate("PBX Main Page"),
translate("This configuration page allows you to configure a phone system (PBX) service which \
      permits making phone calls through multiple Google and SIP (like Sipgate, \
      SipSorcery, and Betamax) accounts and sharing them among many SIP devices. \
      Note that Google accounts, SIP accounts, and local user accounts are configured in the \
      \"Google Accounts\", \"SIP Accounts\", and \"User Accounts\" sub-sections. \
      You must add at least one User Account to this PBX, and then configure a SIP device or \
      softphone to use the account, in order to make and receive calls with your Google/SIP \
      accounts. Configuring multiple users will allow you to make free calls between all users, \
      and share the configured Google and SIP accounts. If you have more than one Google and SIP \
      accounts set up, you should probably configure how calls to and from them are routed in \
      the \"Call Routing\" page. If you're interested in using your own PBX from anywhere in the \
      world, then visit the \"Remote Usage\" section in the \"Advanced Settings\" page."))
s=m:section(NamedSection,"connection_status","main",
translate("PBX Service Status"))
s.anonymous=true
s:option(DummyValue,"status",translate("Service Status"))
sts=s:option(DummyValue,"_sts")
sts.template="cbi/tvalue"
sts.rows=20
function sts.cfgvalue(e,e)
if server=="asterisk"then
regs=luci.sys.exec("asterisk -rx 'sip show registry' | sed 's/peer-//'")
jabs=luci.sys.exec("asterisk -rx 'jabber show connections' | grep onnected")
usrs=luci.sys.exec("asterisk -rx 'sip show users'")
chan=luci.sys.exec("asterisk -rx 'core show channels'")
return format_indices(regs,{1,5})..
format_indices(jabs,{2,4}).."\n"..
format_indices(usrs,{1}).."\n"..chan
elseif server=="freeswitch"then
return"Freeswitch is not supported yet.\n"
else
return"Neither Asterisk nor FreeSwitch discovered, please install Asterisk, as Freeswitch is not supported yet.\n"
end
end
return m
